diff -uNr linux/Makefile linux-2.4.7/Makefile
--- linux/Makefile	Fri Aug  3 05:39:58 2001
+++ linux-2.4.7/Makefile	Wed Apr 17 02:55:34 2002
@@ -1,11 +1,12 @@
 VERSION = 2
 PATCHLEVEL = 4
 SUBLEVEL = 7
-EXTRAVERSION =-rmk2
+EXTRAVERSION =-rmk2-stanson0
 
 KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
 
-ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
+#ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
+ARCH := arm
 
 CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
 	  else if [ -x /bin/bash ]; then echo /bin/bash; \
@@ -16,9 +17,9 @@
 FINDHPATH	= $(HPATH)/asm $(HPATH)/linux $(HPATH)/scsi $(HPATH)/net
 
 HOSTCC  	= gcc
-HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
+HOSTCFLAGS	= -Wall -Wstrict-prototypes -fomit-frame-pointer
 
-CROSS_COMPILE 	=
+CROSS_COMPILE 	= arm-linux-
 
 #
 # Include the make variables (CC, etc...)
diff -uNr linux/arch/arm/Makefile linux-2.4.7/arch/arm/Makefile
--- linux/arch/arm/Makefile	Fri Aug  3 05:39:58 2001
+++ linux-2.4.7/arch/arm/Makefile	Tue Nov 27 02:15:46 2001
@@ -124,6 +124,9 @@
 
 ifeq ($(CONFIG_ARCH_CLPS711X),y)
 TEXTADDR	 = 0xc0018000
+ifeq ($(CONFIG_CLPS7110_PSION),y)
+TEXTADDR	 = 0xc0038000
+endif
 MACHINE		 = clps711x
 endif
 
diff -uNr linux/arch/arm/config.in linux-2.4.7/arch/arm/config.in
--- linux/arch/arm/config.in	Fri Aug  3 05:39:58 2001
+++ linux-2.4.7/arch/arm/config.in	Mon Feb 11 05:36:58 2002
@@ -106,10 +106,17 @@
 fi
 endmenu
 
-mainmenu_option next_comment
-comment 'CLPS711X/EP721X Implementations'
-dep_bool '  P720T' CONFIG_ARCH_P720T $CONFIG_ARCH_CLPS711X
-endmenu
+if [ "$CONFIG_ARCH_CLPS711X" = "y" ]; then
+   mainmenu_option next_comment
+   comment 'CLPS711X/EP721X Implementations'
+   dep_bool '  P720T' CONFIG_ARCH_P720T $CONFIG_ARCH_CLPS7111
+   dep_bool '  CL-PS7110 based' CONFIG_ARCH_CLPS7110 $CONFIG_ARCH_CLPS711X
+   if [ "$CONFIG_ARCH_CLPS7110" = "y" ]; then
+      dep_bool '    Psion Series 5' CONFIG_CLPS7110_PSION $CONFIG_ARCH_CLPS7110
+      dep_bool '    Geofox' CONFIG_CLPS7110_GEOFOX $CONFIG_ARCH_CLPS7110
+   fi
+   endmenu
+fi
 
 # Definitions to make life easier
 if [ "$CONFIG_ARCH_ARCA5K" = "y" -o \
@@ -158,14 +165,15 @@
 comment 'Processor Type'
 
 # Firstly, figure out what processor architecture version we should be using.
-if [ "$CONFIG_ARCH_RPC"        = "y" -o "$CONFIG_ARCH_CLPS7500" = "y" ]; then
+if [ "$CONFIG_ARCH_RPC"        = "y" -o "$CONFIG_ARCH_CLPS7500" = "y" -o \
+     "$CONFIG_ARCH_CLPS7110"   = "y" ]; then
    define_bool CONFIG_CPU_32v3 y
 else
    define_bool CONFIG_CPU_32v3 n
 fi
 if [ "$CONFIG_ARCH_EBSA110"    = "y" -o "$CONFIG_FOOTBRIDGE"    = "y" -o \
      "$CONFIG_ARCH_TBOX"       = "y" -o "$CONFIG_ARCH_SHARK"    = "y" -o \
-     "$CONFIG_ARCH_NEXUSPCI"   = "y" -o "$CONFIG_ARCH_CLPS711X" = "y" -o \
+     "$CONFIG_ARCH_NEXUSPCI"   = "y" -o "$CONFIG_ARCH_P720T"    = "y" -o \
      "$CONFIG_ARCH_INTEGRATOR" = "y" -o "$CONFIG_ARCH_SA1100"   = "y" -o \
      "$CONFIG_ARCH_L7200"      = "y" -o "$CONFIG_ARCH_ANAKIN"	= "y" ]; then
    define_bool CONFIG_CPU_32v4 y
@@ -185,7 +193,7 @@
 fi
 
 # ARM710
-if [ "$CONFIG_ARCH_CLPS7500" = "y" ]; then
+if [ "$CONFIG_ARCH_CLPS7500" = "y" -o "$CONFIG_ARCH_CLPS7110" = "y" ]; then
    define_bool CONFIG_CPU_ARM710 y
 else
    if [ "$CONFIG_ARCH_RPC" = "y" ]; then
@@ -196,7 +204,7 @@
 fi
 
 # ARM720T
-if [ "$CONFIG_ARCH_CLPS711X" = "y" -o "$CONFIG_ARCH_L7200" = "y" ]; then
+if [ "$CONFIG_ARCH_P720T" = "y" -o "$CONFIG_ARCH_L7200" = "y" ]; then
    define_bool CONFIG_CPU_ARM720T y
 else
    if [ "$CONFIG_ARCH_INTEGRATOR" = "y" ]; then
@@ -260,6 +268,7 @@
 #fi
 
 # Select various configuration options depending on the machine type
+#if [ "$CONFIG_ARCH_SA1100" = "y" -o "$CONFIG_CLPS7110_PSION" = "y" ]; then
 if [ "$CONFIG_ARCH_SA1100" = "y" ]; then
    define_bool CONFIG_DISCONTIGMEM y
 else
@@ -335,6 +344,7 @@
      "$CONFIG_ARCH_PERSONAL_SERVER" = "y" -o \
      "$CONFIG_ARCH_CATS" = "y" -o            \
      "$CONFIG_ARCH_P720T" = "y" -o	     \
+     "$CONFIG_ARCH_CLPS7110" = "y" -o	     \
      "$CONFIG_ARCH_ANAKIN" = "y" ]; then
    string 'Default kernel command string' CONFIG_CMDLINE ""
 fi
diff -uNr linux/arch/arm/kernel/arch.c linux-2.4.7/arch/arm/kernel/arch.c
--- linux/arch/arm/kernel/arch.c	Fri Aug  3 05:39:58 2001
+++ linux-2.4.7/arch/arm/kernel/arch.c	Thu Nov 29 01:59:39 2001
@@ -146,12 +146,7 @@
 	INITIRQ(genarch_init_irq)
 MACHINE_END
 #endif
-#ifdef CONFIG_ARCH_CLPS7110
-MACHINE_START(CLPS7110, "CL-PS7110")
-	MAINTAINER("Werner Almesberger")
-	INITIRQ(genarch_init_irq)
-MACHINE_END
-#endif
+
 #ifdef CONFIG_ARCH_ETOILE
 MACHINE_START(ETOILE, "Etoile")
 	MAINTAINER("Alex de Vries")
diff -uNr linux/arch/arm/kernel/debug-armv.S linux-2.4.7/arch/arm/kernel/debug-armv.S
--- linux/arch/arm/kernel/debug-armv.S	Fri Aug  3 05:39:58 2001
+++ linux-2.4.7/arch/arm/kernel/debug-armv.S	Thu Aug  9 06:12:32 2001
@@ -269,13 +269,13 @@
 
 #elif defined(CONFIG_ARCH_CLPS711X)
 
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 
 		.macro	addruart,rx
 		mrc	p15, 0, \rx, c1, c0
 		tst	\rx, #1			@ MMU enabled?
-		moveq	\rx, #CLPS7111_PHYS_BASE
-		movne	\rx, #CLPS7111_VIRT_BASE
+		moveq	\rx, #CLPS711X_PHYS_BASE
+		movne	\rx, #CLPS711X_VIRT_BASE
 #ifndef CONFIG_DEBUG_CLPS711X_UART2
 		add	\rx, \rx, #0x0000	@ UART1
 #else
diff -uNr linux/arch/arm/kernel/entry-armv.S linux-2.4.7/arch/arm/kernel/entry-armv.S
--- linux/arch/arm/kernel/entry-armv.S	Fri Aug  3 05:39:58 2001
+++ linux-2.4.7/arch/arm/kernel/entry-armv.S	Tue Nov 27 02:53:03 2001
@@ -454,17 +454,19 @@
 
 #elif defined(CONFIG_ARCH_CLPS711X)
 
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 
 		.macro	disable_fiq
 		.endm
 
+#if !defined(CONFIG_ARCH_CLPS7110)
 #if (INTSR2 - INTSR1) != (INTMR2 - INTMR1)
 #error INTSR stride != INTMR stride
 #endif
+#endif
 
 		.macro	get_irqnr_and_base, irqnr, stat, base, mask
-		mov	\base, #CLPS7111_BASE
+		mov	\base, #CLPS711X_BASE
 		ldr	\stat, [\base, #INTSR1]
 		ldr	\mask, [\base, #INTMR1]
 		mov	\irqnr, #4
@@ -473,12 +475,14 @@
 		movs	\stat, \stat, lsr #4
 		bne	1001f
 
+#if !defined(CONFIG_ARCH_CLPS7110)
 		add	\base, \base, #INTSR2 - INTSR1
 		ldr	\stat, [\base, #INTSR1]
 		ldr	\mask, [\base, #INTMR1]
 		mov	\irqnr, #16
 		mov	\mask, \mask, lsl #16
 		and	\stat, \stat, \mask, lsr #16
+#endif
 
 1001:		tst	\stat, #255
 		addeq	\irqnr, \irqnr, #8
diff -uNr linux/arch/arm/kernel/head-armv.S linux-2.4.7/arch/arm/kernel/head-armv.S
--- linux/arch/arm/kernel/head-armv.S	Fri Aug  3 05:39:58 2001
+++ linux-2.4.7/arch/arm/kernel/head-armv.S	Sun Feb  3 19:24:13 2002
@@ -184,12 +184,12 @@
 #ifdef CONFIG_ALIGNMENT_TRAP
 		orr	r0, r0, #2			@ ...........A.
 #endif
+
 		bic	r2, r0, #2			@ Clear 'A' bit
 		stmia	r8, {r0, r2}			@ Save control register values
 		b	SYMBOL_NAME(start_kernel)
 
 
-
 /*
  * Setup the initial page tables.  We only setup the barest
  * amount which are required to get the kernel running, which
@@ -210,8 +210,16 @@
 		 * Clear the 16K level 1 swapper page table
 		 */
 		mov	r0, r4
+#if defined(CONFIG_CLPS7110_PSION)
+		/* Clear 8K level 2 table too */
+		sub	r0, r0, #0x2000
+#endif
 		mov	r3, #0
+#if defined(CONFIG_CLPS7110_PSION)
+		add	r2, r0, #0x6000
+#else
 		add	r2, r0, #0x4000
+#endif
 1:		str	r3, [r0], #4
 		str	r3, [r0], #4
 		str	r3, [r0], #4
@@ -219,6 +227,70 @@
 		teq	r0, r2
 		bne	1b
 
+#if defined(CONFIG_CLPS7110_PSION)
+
+		/* calculate physical address from virtual
+		 * see also __virt_to_phys() in 
+		 * include/asm-arm/arch-clps711x/memory.h */
+		.macro	v2phys, virt, phys
+		bic	\phys, \virt, #0x3f000000
+		bic	\phys, \phys, #0x00f80000	@ phys = virt & 0xc007ffff
+		tst	\virt, #0x00200000
+		orrne	\phys, \phys, #0x00200000 << 3	@ phys |= ((virt & 0x00200000) << 3)
+		tst	\virt, #0x00100000
+		orrne	\phys, \phys, #0x00100000 << 2	@ phys |= ((virt & 0x00100000) << 2)
+		tst	\virt, #0x00080000
+		orrne	\phys, \phys, #0x00080000 << 1	@ phys |= ((virt & 0x00080000) << 1)
+		.endm
+
+		/* for Psion S5 we also need a 8 tables for level 2
+		 * descriptors, this region will be used also by
+		 * alloc_init_page, so there will be sequence of
+		 * processor table, kernel table, processor table, etc...
+		 * we fill only processor tables, kernel tables will be
+		 * filled by paging_init() */
+
+		sub	r0, r4, #0x2000
+
+		/* and fill it with info about first 4MB as pages */
+		mov	r2, #TEXTADDR & 0xff000000
+		and	r11, r8, #0x000c		@ C & B flags for page
+		tst	r8, #0x0400
+		orrne	r11, r11, #0x0550
+		tst	r8, #0x0c00
+		orrne	r11, r11, #0x0aa0		@ access permissions
+		orr	r11, r11, #0x2			@ small page
+1:
+		v2phys	r2, r3				@ get physical address
+		orr	r3, r3, r11			@ set flags
+		str	r3, [r0], #4			@ write descriptor
+		add	r2, r2, #0x1000			@ next page
+		tst	r0, #0x00ff
+		tsteq	r0, #0x0300			@ if done with processor table
+		addeq	r0, r0, #0x0400			@ skip kernel table
+		teq	r0, r4
+		bne	1b
+
+		/*
+		 * Now setup the level 1 descriptors for our kernel
+		 * mapped region.  We round TEXTADDR down to the
+		 * nearest megabyte boundary.
+		 */
+		and	r2, r8, #0x01e0			@ Domain
+		orr	r2, r2, #0x0011			@ Page descriptor
+		sub	r0, r4, #0x2000			@ L2 page tables
+		orr	r3, r0, r2
+		add	r0, r4, #(TEXTADDR & 0xff000000) >> 18 @ start of kernel
+		str	r3, [r0], #4			@ KERNEL + 0MB
+		add	r3, r3, #0x0800
+		str	r3, [r0], #4			@ KERNEL + 1MB
+		add	r3, r3, #0x0800
+		str	r3, [r0], #4			@ KERNEL + 2MB
+		add	r3, r3, #0x0800
+		str	r3, [r0]			@ KERNEL + 3MB
+
+#else /* defined(CONFIG_CLPS7110_PSION) */
+
 		/*
 		 * Create identity mapping for first MB of kernel to
 		 * cater for the MMU enable.  This identity mapping
@@ -257,6 +329,8 @@
 		add	r3, r8, r2			@ flags + rambase
 		str	r3, [r0]
 
+#endif /* defined(CONFIG_CLPS7110_PSION) */
+
 		bic	r8, r8, #0x0c			@ turn off cacheable
 							@ and bufferable bits
 #ifdef CONFIG_DEBUG_LL
@@ -420,3 +494,4 @@
 2:		ldmib	r4, {r5, r6, r7}		@ found, get results
 		mov	r7, r7, lsr #18			@ pagetable byte offset
 		mov	pc, lr
+
diff -uNr linux/arch/arm/kernel/setup.c linux-2.4.7/arch/arm/kernel/setup.c
--- linux/arch/arm/kernel/setup.c	Fri Aug  3 05:39:58 2001
+++ linux-2.4.7/arch/arm/kernel/setup.c	Sun Dec  2 03:17:16 2001
@@ -72,6 +72,7 @@
 char elf_platform[ELF_PLATFORM_SIZE];
 char saved_command_line[COMMAND_LINE_SIZE];
 
+//static struct meminfo meminfo __initdata = { 0, };
 static struct meminfo meminfo __initdata = { 0, };
 static struct proc_info_item proc_info;
 static const char *machine_name;
diff -uNr linux/arch/arm/mach-clps711x/Makefile linux-2.4.7/arch/arm/mach-clps711x/Makefile
--- linux/arch/arm/mach-clps711x/Makefile	Fri Aug  3 05:39:59 2001
+++ linux-2.4.7/arch/arm/mach-clps711x/Makefile	Tue Nov 27 03:04:24 2001
@@ -11,7 +11,7 @@
 
 # Object file lists.
 
-obj-y			:= irq.o mm.o
+obj-y			:= irq.o
 obj-m			:=
 obj-n			:=
 obj-			:=
@@ -19,7 +19,9 @@
 export-objs		:= leds-p720t.o
 
 leds-$(CONFIG_ARCH_P720T) += p720t-leds.o
-obj-$(CONFIG_ARCH_P720T) += p720t.o
+leds-$(CONFIG_CLPS7110_PSION) += psion_s5-leds.o
+obj-$(CONFIG_ARCH_P720T) += p720t.o p720t-mm.o
+obj-$(CONFIG_ARCH_CLPS7110) += clps7110.o clps7110-mm.o
 obj-$(CONFIG_LEDS)	+= $(leds-y)
 
 include $(TOPDIR)/Rules.make
diff -uNr linux/arch/arm/mach-clps711x/clps7110-mm.c linux-2.4.7/arch/arm/mach-clps711x/clps7110-mm.c
--- linux/arch/arm/mach-clps711x/clps7110-mm.c	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/arch/arm/mach-clps711x/clps7110-mm.c	Wed Apr 17 07:21:13 2002
@@ -0,0 +1,56 @@
+/*
+ *  linux/arch/arm/mach-clps711x/clps7110-mm.c
+ *
+ *  Extra MM routines for the Psion Series 5
+ *
+ *  Copyright (C) Andrew Kozin AKA Stanson <stanson@chat.ru>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/init.h>
+
+#include <asm/hardware.h>
+#include <asm/pgtable.h>
+#include <asm/page.h>
+ 
+#include <asm/mach/map.h>
+
+#include <asm/hardware/clps711x.h>
+#include <asm/arch/syspld.h>
+
+static struct map_desc clps7110_io_desc[] __initdata = {
+#if defined(CONFIG_PCMCIA_ETNA)
+ { ETNA_VIRT_BASE, ETNA_PHYS_BASE, ETNA_SIZE, DOMAIN_IO, 0, 1},
+#endif
+ { CLPS711X_VIRT_BASE, CLPS711X_PHYS_BASE, 1048576, DOMAIN_IO, 0, 1 },
+ LAST_DESC
+};
+
+void __init clps7110_map_io(void)
+{
+	iotable_init(clps7110_io_desc);
+}
+ 
+void clps7110_adjust_zones(int node, unsigned long *zone_size, unsigned long *zhole_size)
+{
+	int i;
+
+	for (i = 0; i < MAX_NR_ZONES; i++) {
+		zone_size[i] -= zhole_size[i];
+		zhole_size[i] = 0;
+	}
+}
diff -uNr linux/arch/arm/mach-clps711x/clps7110.c linux-2.4.7/arch/arm/mach-clps711x/clps7110.c
--- linux/arch/arm/mach-clps711x/clps7110.c	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/arch/arm/mach-clps711x/clps7110.c	Sun Dec  2 06:16:40 2001
@@ -0,0 +1,102 @@
+/*
+ *  linux/arch/arm/mach-clps711x/psion_s5.c
+ *
+ *  Copyright (C) 2001 Andrew Kozin AKA Stanson <stanson@chat.ru>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/init.h>
+#include <linux/types.h>
+#include <linux/string.h>
+
+#include <asm/hardware.h>
+#include <asm/io.h>
+#include <asm/page.h>
+#include <asm/setup.h>
+#include <asm/mach-types.h>
+#include <asm/mach/arch.h>
+
+#include <asm/hardware/clps711x.h>
+
+extern void clps711x_init_irq(void);
+extern void clps7110_map_io(void);
+
+#define SET_TAG_MEM(_tag,_start,_size)	\
+	{_tag = tag_next(_tag);\
+	_tag->hdr.tag = ATAG_MEM;\
+	_tag->hdr.size = tag_size(tag_mem32);\
+	_tag->u.mem.size = (_size);\
+	_tag->u.mem.start = (_start);}
+
+static void __init
+clps7110_fixup(struct machine_desc *desc, struct param_struct *params,
+	    char **cmdline, struct meminfo *mi)
+{
+	struct tag *tag = (struct tag *)params;
+
+	tag->hdr.tag = ATAG_CORE;
+	tag->hdr.size = tag_size(tag_core);
+	tag->u.core.flags = 0;
+	tag->u.core.pagesize = PAGE_SIZE;
+	tag->u.core.rootdev = 0x0100;
+
+	SET_TAG_MEM(tag, 0xc0000000, 0x00080000);
+	SET_TAG_MEM(tag, 0xc0100000, 0x00080000);
+	SET_TAG_MEM(tag, 0xc0400000, 0x00080000);
+	SET_TAG_MEM(tag, 0xc0500000, 0x00080000);
+
+	SET_TAG_MEM(tag, 0xc1000000, 0x00080000);
+	SET_TAG_MEM(tag, 0xc1100000, 0x00080000);
+	SET_TAG_MEM(tag, 0xc1400000, 0x00080000);
+	SET_TAG_MEM(tag, 0xc1500000, 0x00080000);
+
+	SET_TAG_MEM(tag, 0xd0000000, 0x00080000);
+	SET_TAG_MEM(tag, 0xd0100000, 0x00080000);
+	SET_TAG_MEM(tag, 0xd0400000, 0x00080000);
+	SET_TAG_MEM(tag, 0xd0500000, 0x00080000);
+
+	SET_TAG_MEM(tag, 0xd1000000, 0x00080000);
+	SET_TAG_MEM(tag, 0xd1100000, 0x00080000);
+	SET_TAG_MEM(tag, 0xd1400000, 0x00080000);
+	SET_TAG_MEM(tag, 0xd1500000, 0x00080000);
+
+	tag = tag_next(tag);
+	tag->hdr.tag = ATAG_NONE;
+	tag->hdr.size = 0;
+}
+
+MACHINE_START(CLPS7110, "CL-PS7110")
+	MAINTAINER("Werner Almesberger")
+	BOOT_MEM(0xc0000000, 0x80000000, 0xff000000)
+	BOOT_PARAMS(0xc0023000)
+	FIXUP(clps7110_fixup)
+	MAPIO(clps7110_map_io)
+	INITIRQ(clps711x_init_irq)
+MACHINE_END
+
+static int clps7110_hw_init(void)
+{
+	/*
+	 * Power down as much as possible in case we don't
+	 * have the drivers loaded.
+	 */
+	return 0;
+}
+
+__initcall(clps7110_hw_init);
+
diff -uNr linux/arch/arm/mach-clps711x/irq.c linux-2.4.7/arch/arm/mach-clps711x/irq.c
--- linux/arch/arm/mach-clps711x/irq.c	Fri Aug  3 05:39:59 2001
+++ linux-2.4.7/arch/arm/mach-clps711x/irq.c	Tue Nov 27 02:38:16 2001
@@ -24,7 +24,7 @@
 #include <asm/io.h>
 #include <asm/irq.h>
 
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 
 static void mask_irq_int1(unsigned int irq)
 {
@@ -62,6 +62,24 @@
 	clps_writel(intmr1, INTMR1);
 }
 
+
+#ifdef CONFIG_PCMCIA_ETNA
+static void mask_etna_irq(unsigned int irq)
+{
+	mask_irq_int1(irq);
+	ETNA_INT_MASK = 0;
+	ETNA_INT_CLEAR = ETNA_CF_IRQ;
+}
+
+static void unmask_etna_irq(unsigned int irq)
+{
+	ETNA_INT_MASK = ETNA_CF_IRQ;
+	unmask_irq_int1(irq);
+}
+#endif
+
+#if !defined(CONFIG_ARCH_CLPS7110)
+
 static void mask_irq_int2(unsigned int irq)
 {
 	u32 intmr2;
@@ -93,6 +111,8 @@
 	clps_writel(intmr2, INTMR2);
 }
 
+#endif /* !defined(CONFIG_ARCH_CLPS7110) */
+
 void __init clps711x_init_irq(void)
 {
 	unsigned int i;
@@ -107,6 +127,7 @@
 			irq_desc[i].mask	= mask_irq_int1;
 			irq_desc[i].unmask	= unmask_irq_int1;
 		}
+#if !defined(CONFIG_ARCH_CLPS7110)
 		if (INT2_IRQS & (1 << i)) {
 		        irq_desc[i].valid	= 1;
 			irq_desc[i].probe_ok	= 1;
@@ -116,13 +137,17 @@
 			irq_desc[i].mask	= mask_irq_int2;
 			irq_desc[i].unmask	= unmask_irq_int2;
 		}			
+#endif
 	}
 
 	/*
 	 * Disable interrupts
 	 */
 	clps_writel(0, INTMR1);
+
+#if !defined(CONFIG_ARCH_CLPS7110)
 	clps_writel(0, INTMR2);
+#endif
 
 	/*
 	 * Clear down any pending interrupts
@@ -134,5 +159,14 @@
 	clps_writel(0, TEOI);
 	clps_writel(0, UMSEOI);
 	clps_writel(0, SYNCIO);
+
+#if !defined(CONFIG_ARCH_CLPS7110)
 	clps_writel(0, KBDEOI);
+#endif
+
+#ifdef CONFIG_PCMCIA_ETNA
+	irq_desc[IRQ_EINT1].mask_ack = mask_etna_irq;
+	irq_desc[IRQ_EINT1].unmask = unmask_etna_irq;
+#endif
+
 }
diff -uNr linux/arch/arm/mach-clps711x/p720t-leds.c linux-2.4.7/arch/arm/mach-clps711x/p720t-leds.c
--- linux/arch/arm/mach-clps711x/p720t-leds.c	Fri Aug  3 05:39:59 2001
+++ linux-2.4.7/arch/arm/mach-clps711x/p720t-leds.c	Thu Aug  9 06:13:03 2001
@@ -28,7 +28,7 @@
 #include <asm/system.h>
 #include <asm/mach-types.h>
 
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 #include <asm/hardware/ep7212.h>
 
 static void p720t_leds_event(led_event_t ledevt)
diff -uNr linux/arch/arm/mach-clps711x/p720t-mm.c linux-2.4.7/arch/arm/mach-clps711x/p720t-mm.c
--- linux/arch/arm/mach-clps711x/p720t-mm.c	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/arch/arm/mach-clps711x/p720t-mm.c	Thu Aug  9 06:12:52 2001
@@ -0,0 +1,49 @@
+/*
+ *  linux/arch/arm/mach-clps711x/mm.c
+ *
+ *  Extra MM routines for the ARM Integrator board
+ *
+ *  Copyright (C) 2000 Deep Blue Solutions Ltd
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/init.h>
+
+#include <asm/hardware.h>
+#include <asm/pgtable.h>
+#include <asm/page.h>
+ 
+#include <asm/mach/map.h>
+
+#include <asm/hardware/clps711x.h>
+#include <asm/arch/syspld.h>
+
+/*
+ * Logical      Physical
+ */
+ 
+static struct map_desc p720t_io_desc[] __initdata = {
+ { SYSPLD_VIRT_BASE, SYSPLD_PHYS_BASE, 1048576, DOMAIN_IO, 0, 1},
+ { 0xfe400000, 0x10400000, 1048576, DOMAIN_IO, 0, 1},
+ { CLPS711X_VIRT_BASE, CLPS711X_PHYS_BASE, 1048576, DOMAIN_IO, 0, 1 },
+ LAST_DESC
+};
+
+void __init p720t_map_io(void)
+{
+	iotable_init(p720t_io_desc);
+}
diff -uNr linux/arch/arm/mach-clps711x/psion_s5-leds.c linux-2.4.7/arch/arm/mach-clps711x/psion_s5-leds.c
--- linux/arch/arm/mach-clps711x/psion_s5-leds.c	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/arch/arm/mach-clps711x/psion_s5-leds.c	Fri Aug 10 02:49:54 2001
@@ -0,0 +1,66 @@
+/*
+ *  linux/arch/arm/mach-clps711x/psion_s5-leds.c
+ *
+ *  Integrator LED control routines
+ *
+ *  Copyright (C) 2000 Deep Blue Solutions Ltd
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#include <linux/kernel.h>
+#include <linux/init.h>
+
+#include <asm/hardware.h>
+#include <asm/io.h>
+#include <asm/leds.h>
+#include <asm/system.h>
+#include <asm/mach-types.h>
+
+#include <asm/hardware/clps711x.h>
+
+static void psion_s5_leds_event(led_event_t ledevt)
+{
+	unsigned long flags;
+	u32 pddr;
+
+	local_irq_save(flags);
+	switch(ledevt) {
+	case led_idle_start:
+		break;
+
+	case led_idle_end:
+		break;
+
+	case led_timer:
+		pddr = clps_readb(PDDR);
+		clps_writeb(pddr ^ 0x10, PDDR);
+		break;
+
+	default:
+		break;
+	}
+
+	local_irq_restore(flags);
+}
+
+static int __init leds_init(void)
+{
+	if (machine_is_psion_s5())
+		leds_event = psion_s5_leds_event;
+
+	return 0;
+}
+
+__initcall(leds_init);
diff -uNr linux/arch/arm/mm/discontig.c linux-2.4.7/arch/arm/mm/discontig.c
--- linux/arch/arm/mm/discontig.c	Fri Aug  3 05:39:59 2001
+++ linux-2.4.7/arch/arm/mm/discontig.c	Thu Feb  7 23:04:43 2002
@@ -15,22 +15,34 @@
 #include <linux/init.h>
 #include <linux/bootmem.h>
 
-#if NR_NODES != 4
-#error Fix Me Please
+#if defined(CONFIG_CLPS7110_PSION)
+  #if NR_NODES != 2
+  #error Fix Me Please
+  #endif
+#else
+  #if NR_NODES != 4
+  #error Fix Me Please
+  #endif
 #endif
-
 /*
  * Our node_data structure for discontigous memory.
  */
 
 static bootmem_data_t node_bootmem_data[NR_NODES];
 
+#if defined(CONFIG_CLPS7110_PSION)
+pg_data_t discontig_node_data[NR_NODES] = {
+  { bdata: &node_bootmem_data[0] },
+  { bdata: &node_bootmem_data[1] }
+};
+#else
 pg_data_t discontig_node_data[NR_NODES] = {
   { bdata: &node_bootmem_data[0] },
   { bdata: &node_bootmem_data[1] },
   { bdata: &node_bootmem_data[2] },
   { bdata: &node_bootmem_data[3] }
 };
+#endif
 
 EXPORT_SYMBOL(discontig_node_data);
 
diff -uNr linux/arch/arm/mm/init.c linux-2.4.7/arch/arm/mm/init.c
--- linux/arch/arm/mm/init.c	Fri Aug  3 05:39:59 2001
+++ linux-2.4.7/arch/arm/mm/init.c	Wed Apr 17 16:37:11 2002
@@ -35,9 +35,9 @@
 #include <asm/mach/map.h>
 
 #ifndef CONFIG_DISCONTIGMEM
-#define NR_NODES	1
+  #define NR_NODES	1
 #else
-#define NR_NODES	4
+  #define NR_NODES	4
 #endif
 
 #ifdef CONFIG_CPU_32
@@ -343,15 +343,21 @@
 	 * Register the kernel text and data with bootmem.
 	 * Note that this can only be in node 0.
 	 */
-	reserve_bootmem_node(pgdat, __pa(&_stext), &_end - &_stext);
+	reserve_bootmem_node(pgdat, __pa(&_stext), __pa(&_end) - __pa(&_stext));
 
 #ifdef CONFIG_CPU_32
+#if !defined(CONFIG_CLPS7110_PSION)
 	/*
 	 * Reserve the page tables.  These are already in use,
 	 * and can only be in node 0.
 	 */
 	reserve_bootmem_node(pgdat, __pa(swapper_pg_dir),
 			     PTRS_PER_PGD * sizeof(void *));
+#else
+	/* Reserve the Level 2 table */
+	reserve_bootmem_node(pgdat, __pa(swapper_pg_dir) - PAGE_SIZE * 2, 
+			     PTRS_PER_PGD * sizeof(void *) + PAGE_SIZE * 2);
+#endif
 #endif
 	/*
 	 * And don't forget to reserve the allocator bitmap,
@@ -384,6 +390,11 @@
 	 */
 	reserve_bootmem_node(pgdat, PHYS_OFFSET, __pa(swapper_pg_dir)-PHYS_OFFSET);
 #endif
+#ifdef CONFIG_ARCH_CLPS711X
+#include <asm/hardware/clps711x.h>
+        /* Reserve the video memory area */
+        reserve_bootmem_node(pgdat, CLPS711X_LCD_MEM_BASE, CLPS711X_LCD_MEM_SIZE);
+#endif
 }
 
 /*
@@ -589,13 +600,19 @@
 	initpages = &__init_end - &__init_begin;
 
 	high_memory = (void *)__va(meminfo.end);
+#if defined(CONFIG_CLPS7110_PSION)
+	max_mapnr   = (meminfo.end - PHYS_OFFSET) >> PAGE_SHIFT;
+#else
 	max_mapnr   = virt_to_page(high_memory) - mem_map;
-
+#endif
 	/*
 	 * We may have non-contiguous memory.
 	 */
+
+#if !defined(CONFIG_CLPS7110_PSION)
 	if (meminfo.nr_banks != 1)
 		create_memmap_holes(&meminfo);
+#endif
 
 	/* this will put all unused low memory onto the freelists */
 	for (node = 0; node < numnodes; node++)
@@ -610,15 +627,22 @@
 	 * Since our memory may not be contiguous, calculate the
 	 * real number of pages we have in this system
 	 */
-	printk(KERN_INFO "Memory:");
+	printk(KERN_INFO "Memory map:\n");
 
 	num_physpages = 0;
 	for (i = 0; i < meminfo.nr_banks; i++) {
 		num_physpages += meminfo.bank[i].size >> PAGE_SHIFT;
-		printk(" %ldMB", meminfo.bank[i].size >> 20);
+		printk(KERN_INFO "  bank %d: %lx - %lx, ", i,
+			meminfo.bank[i].start,
+			meminfo.bank[i].start + meminfo.bank[i].size);
+		if(meminfo.bank[i].size >> 20)
+			printk("%ldMB\n", meminfo.bank[i].size >> 20);
+		else
+			printk("%ldKB\n", meminfo.bank[i].size >> 10);
+			
 	}
 
-	printk(" = %luMB total\n", num_physpages >> (20 - PAGE_SHIFT));
+	printk(KERN_INFO "%luMB total\n", num_physpages >> (20 - PAGE_SHIFT));
 	printk(KERN_NOTICE "Memory: %luKB available (%dK code, "
 		"%dK data, %dK init)\n",
 		(unsigned long) nr_free_pages() << (PAGE_SHIFT-10),
diff -uNr linux/drivers/char/Makefile linux-2.4.7/drivers/char/Makefile
--- linux/drivers/char/Makefile	Fri Aug  3 05:40:00 2001
+++ linux-2.4.7/drivers/char/Makefile	Tue Nov 27 03:42:10 2001
@@ -81,6 +81,10 @@
   ifeq ($(CONFIG_KMI_KEYB),y)
     KEYBD    := amba_kmi_keyb.o
   endif
+  ifeq ($(CONFIG_CLPS7110_PSION),y)
+    KEYMAP   := keymap_psion.o
+#    KEYBD    := kbd_clps7110.o
+  endif
 endif
 
 ifeq ($(ARCH),sh)
@@ -262,3 +266,6 @@
 
 defkeymap.c: defkeymap.map
 	loadkeys --mktable defkeymap.map > defkeymap.c
+
+keymap_psion.c: keymap_psion.map
+	loadkeys --mktable keymap_psion.map > keymap_psion.c
